import hashlib
import json
import hmac
import base64

import jwt


SECRET_KEY = 'BwzBFTfdNJfVWi2CY1BK9KQBDdb5auQR'


def get_token_by_lib(username: str) -> str:
    payload = {"sub": f"{username}"}

    return jwt.encode(payload, SECRET_KEY, algorithm='HS256')


def get_token(username: str) -> str:

    header = {"alg": "HS256", "typ": "JWT"}
    payload = {"sub": f"{username}"}

    encoded_header = base64.urlsafe_b64encode(
        json.dumps(header).encode()
    ).decode('utf-8')

    encoded_payload = base64.urlsafe_b64encode(
        json.dumps(payload).encode()
    ).decode('utf-8')

    unsigned_token = encoded_header + '.' + encoded_payload

    signature = hmac.new(SECRET_KEY.encode(), unsigned_token.encode(), hashlib.sha256).digest()

    return encoded_header + '.' + encoded_payload + '.' + base64.urlsafe_b64encode(signature).decode()
